<?php
/***************************************************************************
*                                                                          *
*    Copyright (c) 2009 Simbirsk Technologies Ltd. All rights reserved.    *
*                                                                          *
* This  is  commercial  software,  only  users  who have purchased a valid *
* license  and  accept  to the terms of the  License Agreement can install *
* and use this program.                                                    *
*                                                                          *
****************************************************************************
* PLEASE READ THE FULL TEXT  OF THE SOFTWARE  LICENSE   AGREEMENT  IN  THE *
* "copyright.txt" FILE PROVIDED WITH THIS DISTRIBUTION PACKAGE.            *
****************************************************************************/

// $Id: checkout.pre.php by andplus 2022

use Tygh\Registry;
use Tygh\Tygh;

if (!defined('BOOTSTRAP')) { die('Access denied'); }

if ($mode == 'checkout') {

	//session(カートデータ)
	$ap_session = $_SESSION['cart'];
	
	//登録済みの事前トークンを呼び出しておく act_as_userの時は事前トークンは呼び出さない形に
	if(!empty($ap_session['user_data']['user_id']) && !empty($auth['user_id']) && empty($auth['act_as_user'])) {
		$pre_token = db_get_field('SELECT user_token FROM ?:users WHERE user_id = ?i', $ap_session['user_data']['user_id']);
		if(!empty($pre_token) && $ap_session['user_data']['user_id'] === $auth['user_id']) {
			//事前トークンが存在し、かつカートのuser_idとauthのuser_idが一致するようならassign
			Tygh::$app['view']->assign('pre_token', $pre_token);
		}
	}
	
	//transaction_idの格納
	if(!empty($_REQUEST['transaction_id'])) {
		$transaction_id = $_REQUEST['transaction_id'];
		//sessionに値を格納
		$_SESSION['transaction_id'] = $transaction_id;
	}

	//POSTした時
	if ($_SERVER['REQUEST_METHOD'] == 'POST' && ( !empty($_REQUEST['pre_token']) || !empty($_REQUEST['transaction_no']) || !empty($_REQUEST['atonecancel']) )) {
		//事前トークンの格納
		if(!empty($_REQUEST['pre_token']) && !empty($ap_session['user_data']['user_id']) && !empty($auth['user_id']) && empty($auth['act_as_user'])) {
			if((int)$ap_session['user_data']['user_id'] === (int)$auth['user_id']) {
				$set_pre_token = $_REQUEST['pre_token'];
				//取得した時点でもDBに保存
				db_query('UPDATE ?:users SET user_token = ?s WHERE user_id = ?i',$set_pre_token, (int)$auth['user_id']);
				$_SESSION['pre_token'] = $set_pre_token;
			}
		}
		
		//transaction_noの格納
		if(!empty($_REQUEST['transaction_no'])) {
			$transaction_no = $_REQUEST['transaction_no'];
			//sessionに値を格納
			$_SESSION['transaction_no'] = $transaction_no;
		}
		
		//モーダルを閉じた場合・atone側での決裁に失敗した場合にsessionに格納した値を一旦空にする
		if(!empty($_REQUEST['atonecancel'])) {
			if(!empty($_SESSION['transaction_no'])) {
				unset($_SESSION['transaction_no']);
			}
			if(!empty($_SESSION['transaction_id'])) {
				unset($_SESSION['transaction_id']);
			}
			if(!empty($_SESSION['pre_token'])) {
				unset($_SESSION['pre_token']);
			}
		}
		exit;
	}   
}
